# coding: utf-8

"""
    Merlin

    API Guide for accessing Merlin's model management, deployment, and serving functionalities

    The version of the OpenAPI document: 0.14.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr
from client.models.gpu_toleration import GPUToleration
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class GPUConfig(BaseModel):
    """
    GPUConfig
    """ # noqa: E501
    name: Optional[StrictStr] = None
    values: Optional[List[StrictStr]] = None
    resource_type: Optional[StrictStr] = None
    node_selector: Optional[Dict[str, StrictStr]] = None
    tolerations: Optional[List[GPUToleration]] = None
    min_monthly_cost_per_gpu: Optional[Union[StrictFloat, StrictInt]] = None
    max_monthly_cost_per_gpu: Optional[Union[StrictFloat, StrictInt]] = None
    __properties: ClassVar[List[str]] = ["name", "values", "resource_type", "node_selector", "tolerations", "min_monthly_cost_per_gpu", "max_monthly_cost_per_gpu"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GPUConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in tolerations (list)
        _items = []
        if self.tolerations:
            for _item in self.tolerations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tolerations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of GPUConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "values": obj.get("values"),
            "resource_type": obj.get("resource_type"),
            "node_selector": obj.get("node_selector"),
            "tolerations": [GPUToleration.from_dict(_item) for _item in obj.get("tolerations")] if obj.get("tolerations") is not None else None,
            "min_monthly_cost_per_gpu": obj.get("min_monthly_cost_per_gpu"),
            "max_monthly_cost_per_gpu": obj.get("max_monthly_cost_per_gpu")
        })
        return _obj


